#pragma comment(lib, "winmm.lib")

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <locale.h>
#include <assert.h>
#include <conio.h>
#include <tchar.h>

#pragma pack(push, 1)
typedef struct
{
	CHAR szChunkID[4]; // ׻ 'R', 'I', 'F', 'F' 4 ASCII ڰ ɴϴ.
	DWORD dwChunkSize; //  ʵ ٷ     ũ⸦ մϴ.
	CHAR dwFormat[4]; //  ʵ     մϴ. ⿡ 'W', 'A', 'V', 'E' 4 ASCII ڰ ɴϴ.
} RIFF_HEADER;
#pragma pack(pop)

#pragma pack(push, 1)
typedef struct
{
	CHAR szChunkID[4]; // ׻ 'f', 'm', 't', ' ' 4 ASCII ڰ ɴϴ.   ڴ (0x20)Դϴ.
	DWORD dwChunkSize; //  ʵ ٷ     ũ⸦ մϴ.
	WORD wFormatTag; //   մϴ. PCM  1Դϴ.
	WORD nChannels; // ä  մϴ.
	DWORD nSamplesPerSec; // ʴ ø ȸ մϴ.
	DWORD nAvgBytesPerSec; // 1ʴ Ҹ ũ⸦ Ʈ  մϴ.
	WORD nBlockAlign; // ä   Ͽ sample 1ȸ Ʈ  Ÿ Դϴ.
	WORD wBitsPerSample; // 1 äδ sample 1ȸ Ʈ  Ÿ Դϴ.
} RIFF_FORMAT;
#pragma pack(pop)

#pragma pack(push, 1)
typedef struct
{
	CHAR szChunkID[4]; // ׻ 'd', 'a', 't', 'a' 4 ASCII ڰ ɴϴ.
	DWORD dwChunkSize; //  ʵ ٷ     ũ⸦ մϴ.      ũԴϴ.
} RIFF_DATA;
#pragma pack(pop)

RIFF_HEADER riffHeader;
RIFF_FORMAT riffFormat;
RIFF_DATA riffData;

void CALLBACK WaveOutProc(HWAVEOUT hWaveOut, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	static WAVEHDR waveHeader;

	switch (uMsg)
	{
	case WOM_OPEN: // waveOutOpen Լ Ǿ 쿡  κ ó
		_tprintf(TEXT("waveOutProc: WOM_OPEN\n"));
		break;
	case WOM_DONE: // waveOutWrite Լ ۼ   ϷǾ 쿡  κ ó
		_tprintf(TEXT("waveOutProc: WOM_DONE\n"));
		break;
	case WOM_CLOSE: // waveOutClose Լ Ǿ 쿡  κ ó
		_tprintf(TEXT("waveOutProc: WOM_CLOSE\n"));
		break;
	default:
		break;
	}
}

int main(int argc, char * argv[])
{
	TCHAR szWaveFile[MAX_PATH]; // WAVE  Դϴ.
	HANDLE hWaveFile = NULL; // WAVE  д ڵԴϴ.
	DWORD dwWaveFileSize = 0; // WAVE  ũԴϴ.
	DWORD dwWaveFileRead = 0; // о WAVE  ũԴϴ. ̶ dwWaveFileSize   ϴ.

	DWORD dwWaveData = 0; // ޸ Ҵ ũԴϴ. ̶ dwWaveFileRead   ϴ.
	HGLOBAL hWaveData = NULL; // Ҵ ޸𸮿  ڵԴϴ.
	LPBYTE lpWaveData = NULL; // WAVE ͸ а  Դϴ.

	HWAVEOUT hWaveOut = NULL; // WAVE  ġ  ڵԴϴ.
	WAVEFORMATEX waveFormatEx; // WAVE    üԴϴ.

	DWORD dwDelay = 0; // α׷   ðԴϴ. WAVE   ð ϴ.
	WAVEHDR waveHeader; // waveOutPrepareHeader, waveOutUnprepareHeader ϴ üԴϴ.

	// ڵ մϴ.
	_tsetlocale(LC_ALL, TEXT(""));
	//   ̸ մϴ.
	_tcscpy(szWaveFile, TEXT("track01.wav"));

	//  ũ⸦ մϴ.
	hWaveFile = CreateFile(szWaveFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); assert(hWaveFile != NULL);
	{
		dwWaveFileSize = GetFileSize(hWaveFile, NULL); assert(dwWaveFileSize > 0);
	}
	CloseHandle(hWaveFile);

	//  ũ⸸ŭ ޸𸮸 Ҵ ޽ϴ.
	hWaveData = GlobalAlloc(GMEM_MOVEABLE, dwWaveFileSize); assert(hWaveData != NULL);
	{
		//  о ޸𸮿 ϱ
		lpWaveData = GlobalLock(hWaveData); assert(lpWaveData);
		hWaveFile = CreateFile(szWaveFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); assert(hWaveFile != NULL);
		{
			SetFilePointer(hWaveFile, 0, NULL, SEEK_SET);
			ReadFile(hWaveFile, lpWaveData, dwWaveFileSize, &dwWaveFileRead, NULL); assert(dwWaveFileSize == dwWaveFileRead);
		}
		assert(CloseHandle(hWaveFile) != 0);
		assert(GlobalUnlock(hWaveData) == 0);

		//  κ о ü ϱ
		lpWaveData = GlobalLock(hWaveData); assert(lpWaveData != NULL);
		{
			CopyMemory(&riffHeader, lpWaveData, sizeof(RIFF_HEADER));
			lpWaveData += sizeof(RIFF_HEADER);

			CopyMemory(&riffFormat, lpWaveData, sizeof(RIFF_FORMAT));
			lpWaveData += sizeof(RIFF_FORMAT);

			CopyMemory(&riffData, lpWaveData, sizeof(RIFF_DATA));
			lpWaveData += sizeof(RIFF_DATA);
		}
		assert(GlobalUnlock(hWaveFile));
		
		// ̺  ġ 
		lpWaveData = GlobalLock(hWaveData); assert(lpWaveData != NULL);
		{
			//    Ϻθ WAVEFORMAT ü ű
			waveFormatEx.nAvgBytesPerSec = riffFormat.nAvgBytesPerSec;
			waveFormatEx.nBlockAlign = riffFormat.nBlockAlign;
			waveFormatEx.nChannels = riffFormat.nChannels;
			waveFormatEx.nSamplesPerSec = riffFormat.nSamplesPerSec;
			waveFormatEx.wFormatTag = riffFormat.wFormatTag;
			waveFormatEx.wBitsPerSample = riffFormat.wBitsPerSample;
			waveFormatEx.cbSize = 0;

			// Ҹ  ġ 
			assert(waveOutOpen(&hWaveOut, WAVE_MAPPER, &waveFormatEx, (DWORD)WaveOutProc, (DWORD)lpWaveData, CALLBACK_FUNCTION) == MMSYSERR_NOERROR);
			{
				// 1 [sec] ҿ Ʈ  մϴ.
				// (1ȸ ũ[Ʈ] / 8) * (1[sec]  ȸ) * (ä :1=, 2=׷)
				dwDelay = (riffFormat.wBitsPerSample / 8) * riffFormat.nSamplesPerSec * riffFormat.nChannels;
				_tprintf(TEXT("bytesPerSec = %d\n"), dwDelay);

				// α׷ Ǵ  Ű ð մϴ.
				// ("data" ϴ ü dwChunkSize[Ʈ]) / (1[sec] ҿ Ʈ)
				dwDelay = riffData.dwChunkSize / dwDelay;
				_tprintf(TEXT("TotalSec = %d (%02d:%02d)\n"), dwDelay, (dwDelay / 60), (dwDelay % 60));

				waveHeader.lpData = (LPVOID)lpWaveData; // Ҹ Ͱ ִ ġ
				waveHeader.dwBufferLength = riffData.dwChunkSize; // Ҹ  ũ
				waveHeader.dwBytesRecorded = 0;
				waveHeader.dwFlags = 0L;
				waveHeader.dwLoops = 0L;
				waveHeader.dwUser = 0;
				waveHeader.lpNext = NULL;
				waveHeader.reserved = 0L;

				waveOutPrepareHeader(hWaveOut, &waveHeader, sizeof(WAVEHDR));
				{
					waveOutWrite(hWaveOut, &waveHeader, sizeof(WAVEHDR));
					// Ҹ   α׷ Ḧ 
					Sleep(dwDelay + 1000);
				}
				waveOutUnprepareHeader(hWaveOut, &waveHeader, sizeof(WAVEHDR));
			}
			assert(waveOutClose(hWaveOut) == MMSYSERR_NOERROR);
		}
		GlobalUnlock(hWaveData);
	}
	GlobalFree(hWaveData);

	_tprintf(TEXT("END"));
	_getch();

	return 0;
}